#!/usr/bin/perl

# guest.cgi
#########################################
#         WOguest Final
#  produced by Andrey Vladimirtsev 2002
#  WOscripts.com @ 1999-2002
#  http://woart.woscripts.com
#  wo@womail.net
#
#########################################

# ***************** Variables *********************
my $filename="guest.cgi";
# *************************************************
# ******************* Modules *********************
use CGI::Carp qw/fatalsToBrowser/;
use locale;
use strict;
require "lib/wolib.pl";
use vars qw/%in $html_output $system $datafd/;
srand();
# *************************************************

$datafd="data";

# ================ Get form data ==================
my $buffer;
if ($ENV{'REQUEST_METHOD'} =~ /POST/i)
{
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else
{
          $buffer = $ENV{'QUERY_STRING'};
}
my @pairs = split(/\&/, $buffer);
foreach my $pair (@pairs)
{
        my($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $in{$name} = $value;
}
# =================================================


$|++;
# *************************** MAIN PART ************************** #
# **************** Default Vars ******************* #
                  #=== Main setup ===#
       open(FILE, "<$datafd/setup/setup.data") or warn("Can't open setup file to read\n",$!);
             my @setup=<FILE>;
       close(FILE);
       chomp @setup;
       my %setup=();
       foreach (@setup){
             my($n,$v)=split(/=/,$_);
             $setup{$n} = $v;
       }

       $system = $setup{'system'};

       open(FILE, "<$datafd/lng/$setup{'lng'}/errors.lng") or warn("Can't open language errors file to read\n",$!);
             my @error=<FILE>;
       close(FILE);
       chomp @error;
       my %error=();
       foreach (@error){
             my($n,$v)=split(/\~/,$_);
             $error{$n} = $v;
       }

       open(FILE, "<$datafd/lng/$setup{'lng'}/signs.lng") or warn("Can't open language errors file to read\n",$!);
             my @sign=<FILE>;
       close(FILE);
       chomp @sign;
       my %sign=();
       foreach (@sign){
             my($n,$v)=split(/\~/,$_);
             $sign{$n} = $v;
       }

       open(FILE, "<$datafd/lng/$setup{'lng'}/date.lng") or warn("Can't open language errors file to read\n",$!);
             my @date=<FILE>;
       close(FILE);
       chomp @date;
       my %date=();
       foreach (@date){
             my($n,$v)=split(/\~/,$_);
             $date{$n} = $v;
       }

# -----------------------------------------------------------------
unless (-e "$datafd/data.data"){
         print "Location: admin/admin.cgi\n\n";
         exit;
}

if ($in{'a'} eq 'a'){
      add_form();
}
else {
      main();
}
# *************************** SUBS PART ************************** #

# *************************** SUB main *************************** #
sub main {
            my $show='';
            my $soob='';
            my $messages = '';

            my @bad_words = split(/\&/,$setup{'bad_words'});
            my %bad_words=();
            foreach (@bad_words){
                  my($n,$v) = split(/\:/,$_);
                  $bad_words{$n} = $v;
            }

            open (FILE, "<$datafd/templates/temp.m.data") or die("Can't open template file for reading\n",$!);
                  flock FILE,1 if $system ne "NT";
                  while (<FILE>){
                       $show .= $_;
                  }
            close(FILE);


            open (FILE, "<$datafd/templates/temp.s.data") or die("Can't open template file for reading\n",$!);
                  flock FILE,1 if $system ne "NT";
                  while (<FILE>){
                       $soob .= $_;
                  }
            close(FILE);

            open (FILE, "<$datafd/data.data") or die("Can't open data file for reading\n",$!);
                  flock FILE,1 if $system ne "NT";
                  my @data = <FILE>;
            close(FILE);

            if ($setup{'top'} eq 'yes'){
                  @data = reverse(@data);
            }

            my $num_data=scalar(@data);

            my $view_on_page = $setup{'num_mess'};
            my $cut_pages = $setup{'num_pages'};
            my $out='';
# ------------- Numbers of pages -----------------------#
                  my($page,$i,$start_page,$stop_page,$start,$stop);

                  if ($in{'p'}){
                        $page=$in{'p'};
                  }
                  else {
                        $page=1;
                  }

                  $view_on_page=1 if $view_on_page == 0;

                  my $first_data=$page;
                  my $last_data=$page+$view_on_page-1;

                  $last_data=$num_data if $last_data > $num_data;

                  my $num_block=int(($num_data-1)/$view_on_page)+1;
                  my $current_page = int($page/$view_on_page);

                  if ($current_page < int(($cut_pages-1)/2)+1) {
                        $start_page = 1;
                        $stop_page = $cut_pages;
                  }
                  elsif ($num_block - $current_page < int(($cut_pages-1)/2)+1 and $cut_pages < int($num_data / $view_on_page)+1) {
                        $start_page = $num_block - $cut_pages+1;
                        $stop_page = $num_block;
                  }
                  elsif ($num_block - $current_page < int(($cut_pages-1)/2)+1 and $cut_pages >= int($num_data / $view_on_page)+1) {
                        $start_page = 1;
                        $stop_page = $num_block;
                  }
                  else {
                        $start_page = $current_page - int($cut_pages/2-1);
                        $stop_page = $current_page + int(($cut_pages-1)/2)+1;
                  }

                  my $out1;
                  unless ($start_page == 1 ) {
                        $out .= "<a href=\"$filename?p=1\"></a>&nbsp;\n";
                  }
                  else {
                        $out .= "&nbsp;";
                        $start_page = 1;
                  }

                  if  ($stop_page > $num_block ) {
                        $stop_page = $num_block;
                  }

                  for($i=$start_page; $i<=$stop_page; $i++)
                  {
                        $start=($i-1)*$view_on_page+1;
                        $stop=$i*$view_on_page;

                        $stop=$num_data if $stop > $num_data;

                        if ($first_data == $start){
                              $out1.=" [<b>$i</b>] ";
                        }
                        else {
                              $out1.=" <a href=\"$filename?p=$start\">$i</a> \n";
                        }
                  }
                  my $back = $first_data-$view_on_page;

                  if ($back <= 0){
                        $out.="&nbsp;";
                  }
                  else {
                        $out.=qq~<a href="$filename?p=$back"></a>&nbsp; \n~;
                  }

                  $out.="$out1";
                  my $next= $first_data+$view_on_page;
                  if ($next > $num_data){
                        $out.="&nbsp;";
                  }
                  else {
                        $out.=qq~&nbsp;<a href="$filename?p=$next"></a>\n~;
                  }
                  unless (int((($stop-1)/2)+1)*2 == $num_block) {
                        my $end = ($num_block-1) * $view_on_page+1;

                        if ($start >= $num_data-$view_on_page) {
                              $out .= " ";
                        }
                        else {
                              $out .= " <a href=\"$filename?p=$end\"></a>\n";
                        }

                  }

# -------------------------------------------------------------------

            my $bg=1;
            my $tmp;
            foreach (my $k=$first_data-1; $k<=$last_data-1; $k++){

                  my($id,$name,$email,$url,$icq,$country,$city,$other1,$other2,$other3,$smile,$ip,$date,$time,$wday,$message,$admin)=split(/\|/,$data[$k]);

                  my $html_out = $soob;

                  my $bgcolor='';
                  if ($bg==1){$bgcolor="$setup{'bg1'}"; $bg++;}
                  else {$bgcolor="$setup{'bg2'}"; $bg--;}


# =================== bad words ===================== #
                  foreach my $item (keys(%bad_words)){
                        $message =~ s/\b$item\b/$bad_words{$item}/ig;
                  }
# ==================== WOcodes ====================== #
                  if ($setup{'let_wo'} eq 'yes'){
# ---------------------- Message ----------------------- #

                        $message =~ s/\(c\)/&copy;/ig;
                        $message =~ s/\(r\)/&reg;/ig;
                        $message =~ s/\(tm\)/&#153;/ig;

                        $message =~ s/\[hr\]/<hr>/ig;

                        $message =~ s|(\[b\])(.+?)(\[/b\])|\<b\>$2\<\/b\>|isg;
                        $message =~ s|(\[i\])(.+?)(\[/i\])|\<i\>$2\<\/i\>|isg;
                        $message =~ s|(\[u\])(.+?)(\[/u\])|\<u\>$2\<\/u\>|isg;
                        $message =~ s|(\[s\])(.+?)(\[/s\])|\<s\>$2\<\/s\>|isg;
                        $message =~ s|(\[o\])(.+?)(\[/o\])|<span style="text-decoration: overline">$2\<\/span\>|isg;
                        $message =~ s|(\[sub\])(.+?)(\[/sub\])|\<sub\>$2\<\/sub\>|isg;
                        $message =~ s|(\[sup\])(.+?)(\[/sup\])|\<sup\>$2\<\/sup\>|isg;

                        $message =~ s|(\[l\])(.+?)(\[/l\])|\<div align="left"\>$2\<\/div\>|isg;
                        $message =~ s|(\[c\])(.+?)(\[/c\])|\<div align="center"\>$2\<\/div\>|isg;
                        $message =~ s|(\[r\])(.+?)(\[/r\])|\<div align="right"\>$2\<\/div\>|isg;
                        $message =~ s|(\[j\])(.+?)(\[/j\])|\<div align="justify"\>$2\<\/div\>|isg;

                        $message =~ s|\[size=\s*(.*?)\s*\]\s*(.*?)\s*\[\/size\]|my $size=check_size($1);"<span style='font-size:".$size."pt;'>$2</span>"|eisg;
                        $message =~ s|\[font=\s*(.*?)\s*\]\s*(.*?)\s*\[\/font\]|<span style='font-family:$1'>$2</span>|isg;
                        $message =~ s|\[color=\s*(.*?)\s*\]\s*(.*?)\s*\[\/color\]|<span style='color:$1'>$2</span>|isg;


                        $message =~ s!(^|\s)(http://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)(https://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)(ftp://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)!$1<a href=\"mailto:$2\">$2</a>!isg;

                        $message =~ s|\[img\](.+?)\[/img\]|my $url = $1; "<img src=\"$1\" border=\"0\">"|gei;
                        $message =~ s|\[email\](\S+?)\[/email\]|<a href="mailto:$1">$1</a>|ig;
                        $message =~ s|\[url\](\S+?)\[/url\]|"<a href=\"$1\" target='_blank'>".($tmp=chomp_url($1))."</a>"|eig;
                        $message =~ s|\[url\s*=\s*(\S+?)\s*\](.*?)\[\/url\]|"<a href=\"$1\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"|eisg;
                        $message =~ s|\[email\s*=\s*(\S+?)\s*\](.*?)\[\/email\]|<a href="mailto:$1">$2</a>|isg;

                        $message =~ s!\[br\]!<br>!ig;
                        $message =~ s!\[list\]!<ul>!isg;
                        $message =~ s!\[\*\]!<li>!isg;
                        $message =~ s!\[\/list\]!</ul>!isg;


                        $message =~ s{\[quote\]}   {
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{99}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;
                        $message =~ s{\[/quote\]}  {qq[</td></tr></table>];}eisgx;

                        $message =~ s{\[quote=(.+?)\]}   {
                                   my $name = $1;
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><span style="font-size:10px;"><b>$sign{99}</b> ($name)</span></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;

                        $message =~ s{\[/quote\]}  {qq[</td></tr></table>];}eisgx;


                        $message =~ s{\[q\]}   {
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{99}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;
                        $message =~ s{\[q=(.+?)\]}   {
                                   my $name = $1;
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><span style="font-size:10px;"><b>$sign{99}</b> ($name)</span></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;

                        $message =~ s{\[/q\]}  {qq[</td></tr></table>];}eisgx;

                        while ($message =~ s{\[code\]([\S\s].+?[\S\s])\[/code\]}
                                     {my $tmp = $1;
                                      $tmp =~ s!&lt;!&#60;!g;
                                      $tmp =~ s!&gt;!&#62;!g;
                                      $tmp =~ s!&quot;!&#34;!g;
                                      $tmp =~ s!\s{1};!&#59;!g;
                                      $tmp =~ s!:!&#58;!g;
                                      $tmp =~ s!\[!&#91;!g;
                                      $tmp =~ s!\]!&#93;!g;
                                      $tmp =~ s!\)!&#41;!g;
                                      $tmp =~ s!\(!&#40;!g;
                                      $tmp = qq|<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{100}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">$tmp</td></tr></table>|;
                                     }exisog) {}
# ------------------------ Admin ------------------------- #

                        $admin =~ s/\(c\)/&copy;/ig;
                        $admin =~ s/\(r\)/&reg;/ig;
                        $admin =~ s/\(tm\)/&#153;/ig;

                        $admin =~ s/\[hr\]/<hr>/ig;

                        $admin =~ s|(\[b\])(.+?)(\[/b\])|\<b\>$2\<\/b\>|isg;
                        $admin =~ s|(\[i\])(.+?)(\[/i\])|\<i\>$2\<\/i\>|isg;
                        $admin =~ s|(\[u\])(.+?)(\[/u\])|\<u\>$2\<\/u\>|isg;
                        $admin =~ s|(\[s\])(.+?)(\[/s\])|\<s\>$2\<\/s\>|isg;
                        $admin =~ s|(\[o\])(.+?)(\[/o\])|<span style="text-decoration: overline">$2\<\/span\>|isg;
                        $admin =~ s|(\[sub\])(.+?)(\[/sub\])|\<sub\>$2\<\/sub\>|isg;
                        $admin =~ s|(\[sup\])(.+?)(\[/sup\])|\<sup\>$2\<\/sup\>|isg;

                        $admin =~ s|(\[l\])(.+?)(\[/l\])|\<div align="left"\>$2\<\/div\>|isg;
                        $admin =~ s|(\[c\])(.+?)(\[/c\])|\<div align="center"\>$2\<\/div\>|isg;
                        $admin =~ s|(\[r\])(.+?)(\[/r\])|\<div align="right"\>$2\<\/div\>|isg;
                        $admin =~ s|(\[j\])(.+?)(\[/j\])|\<div align="justify"\>$2\<\/div\>|isg;

                        $admin =~ s|\[size=\s*(.*?)\s*\]\s*(.*?)\s*\[\/size\]|my $size=check_size($1);"<span style='font-size:".$size."pt;'>$2</span>"|eisg;
                        $admin =~ s|\[font=\s*(.*?)\s*\]\s*(.*?)\s*\[\/font\]|<span style='font-family:$1'>$2</span>|isg;
                        $admin =~ s|\[color=\s*(.*?)\s*\]\s*(.*?)\s*\[\/color\]|<span style='color:$1'>$2</span>|isg;


                        $admin =~ s!(^|\s)(http://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)(https://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)(ftp://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)!$1<a href=\"mailto:$2\">$2</a>!isg;

                        $admin =~ s|\[img\](.+?)\[/img\]|my $url = $1; "<img src=\"$1\" border=\"0\">"|gei;
                        $admin =~ s|\[email\](\S+?)\[/email\]|<a href="mailto:$1">$1</a>|ig;
                        $admin =~ s|\[url\](\S+?)\[/url\]|"<a href=\"$1\" target='_blank'>".($tmp=chomp_url($1))."</a>"|eig;
                        $admin =~ s|\[url\s*=\s*(\S+?)\s*\](.*?)\[\/url\]|"<a href=\"$1\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"|eisg;
                        $admin =~ s|\[email\s*=\s*(\S+?)\s*\](.*?)\[\/email\]|<a href="mailto:$1">$2</a>|isg;

                        $admin =~ s!\[br\]!<br>!ig;
                        $admin =~ s!\[list\]!<ul>!isg;
                        $admin =~ s!\[\*\]!<li>!isg;
                        $admin =~ s!\[\/list\]!</ul>!isg;


                        $admin =~ s{\[quote\]}   {
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{99}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;
                        $admin =~ s{\[/quote\]}  {qq[</td></tr></table>];}eisgx;

                        $admin =~ s{\[quote=(.+?)\]}   {
                                   my $name = $1;
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><span style="font-size:10px;"><b>$sign{99}</b> ($name)</span></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;

                        $admin =~ s{\[/quote\]}  {qq[</td></tr></table>];}eisgx;


                        $admin =~ s{\[q\]}   {
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{99}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;
                        $admin =~ s{\[q=(.+?)\]}   {
                                   my $name = $1;
                                   qq[<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><span style="font-size:10px;"><b>$sign{99}</b> ($name)</span></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">];
                                 }eisgx;

                        $admin =~ s{\[/q\]}  {qq[</td></tr></table>];}eisgx;


                        while ($admin =~ s{\[code\]([\S\s].+?[\S\s])\[/code\]}
                                     {my $tmp = $1;
                                      $tmp =~ s!&lt;!&#60;!g;
                                      $tmp =~ s!&gt;!&#62;!g;
                                      $tmp =~ s!&quot;!&#34;!g;
                                      $tmp =~ s!\s{1};!&#59;!g;
                                      $tmp =~ s!:!&#58;!g;
                                      $tmp =~ s!\[!&#91;!g;
                                      $tmp =~ s!\]!&#93;!g;
                                      $tmp =~ s!\)!&#41;!g;
                                      $tmp =~ s!\(!&#40;!g;
                                      $tmp = qq|<table border="0" align="center" width="95%" cellpadding="3" cellspacing="1"><tr><td><b><span style="font-size:10px;">$sign{100}</span></b></td></tr><tr><td bgcolor="#F5F5F5" style="border:1px solid #c0c0c0;">$tmp</td></tr></table>|;
                                     }exisog) {}
# -------------------------------------------------------- #
                  }
                  else {
                        $message =~ s!(^|\s)(http://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)(https://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)(ftp://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $message =~ s!(^|\s)([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)!$1<a href=\"mailto:$2\">$2</a>!isg;

                        $admin =~ s!(^|\s)(http://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)(https://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)(ftp://\S+)!$1."<a href=\"".$2."\" target=\"_blank\">".($tmp=chomp_url($2))."</a>"!eig;
                        $admin =~ s!(^|\s)([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)!$1<a href=\"mailto:$2\">$2</a>!isg;

                  }

# =================================================== #


# ==================== EMOTIONS ===================== #
                  if ($setup{'emotions'} eq 'yes'){

                        my @emotions = qw/alien angry baaa bigsmile blush
                        boom bored butbut bzz colgate cool
                        crazy cry cry2 death devil dont dontgetit
                        dozingoff eh evil exclamation fuck happy hehe hmm holiday huh huh2 inlove laugh lol lookaround
                        mad music nep nervous notify omg plain rolleyes rotflmao sadlike sarcasm satisfied shaun
                        sigh sleeping sly smoke sneaky sneaky2 thumbs-up tounge2 turn unhappy whatsthat
                        withstupid xmas yinyang yin-yang/;


                        foreach (@emotions){
                              $message =~ s/\:$_\:/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/$_.gif\" alt=\"$_\">\n/g;
                        }
                        $message =~ s/\:\)/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/smile.gif\" alt=\"smile\">\n/g;
                        $message =~ s/\:-\)/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/smile.gif\" alt=\"smile\">\n/g;

                        $message =~ s/\:\(/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/sad.gif\" alt=\"sad\">\n/g;
                        $message =~ s/\:-\(/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/sad.gif\" alt=\"sad\">\n/g;

                        $message =~ s/\:D/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/biggrin.gif\" alt=\"biggrin\">\n/g;

                        $message =~ s/\;\)/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/wink.gif\" alt=\"wink\">\n/g;
                        $message =~ s/\;-\)/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/wink.gif\" alt=\"wink\">\n/g;

                        $message =~ s/\?\?\?/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/confused.gif\" alt=\"confused\">\n/g;
                        $message =~ s/\:0/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/wow.gif\" alt=\"wow\">\n/g;
                        $message =~ s/\:p/<img border=\"0\" src=\"$setup{'non_cgi'}\/emotions\/tounge.gif\" alt=\"tounge\">\n/g;
                 }
# =================================================== #



                  $smile = qq~ <img border="0" src="$setup{'non_cgi'}/smiles/$smile.gif">~ if ($smile);

                              $admin = qq~<br>
                              <table border="0" cellpadding="0" cellspacing="0" width="100%">
                              <tr>
                              <td valign="top" width="5%"><b>$sign{'91'}:&nbsp; </b></td>
                              <td width="95%">$admin</td>
                              </tr>
                              </table>  <br>~ if ($admin);
                  $url = qq~<a target="_blank" href="$url">Web Page</a>~ if ($url);
                  $email = 'n/a' unless ($email);

                  $html_out =~ s/\$NAME\$/$name/g;
                  $html_out =~ s/\$EMAIL\$/$email/g;
                  $html_out =~ s/\$URL\$/$url/g;
                  $html_out =~ s/\$ICQ\$/$icq/g;
                  $html_out =~ s/\$COUNTRY\$/$country/g;
                  $html_out =~ s/\$CITY\$/$city/g;
                  $html_out =~ s/\$OTHER1\$/$other1/g;
                  $html_out =~ s/\$OTHER2\$/$other2/g;
                  $html_out =~ s/\$OTHER3\$/$other3/g;
                  $html_out =~ s/\$SMILE\$/$smile/g;
                  $html_out =~ s/\$IP\$/$ip/g;
                  $html_out =~ s/\$DATE\$/$date/g;
                  $html_out =~ s/\$TIME\$/$time/g;
                  $html_out =~ s/\$WDAY\$/$wday/g;
                  $html_out =~ s/\$MESSAGE\$/$message/g;
                  $html_out =~ s/\$ADMIN\$/$admin/g;
                  $html_out =~ s/\$BGCOLOR\$/$bgcolor/g;


                  $messages .= $html_out;
            }
            my $info = qq~
                  $sign{'92'} <b>$first_data-$last_data</b> $sign{'93'} <b>$num_data</b>
            ~;
            unless ($data[0]){
                  $messages = "$sign{'4'}";
            }
            my $banner = rotator();
            my $add = add();

            if ($in{'e'} eq '1'){
                  $messages .= qq~<script> scriptlanguarge="Javascript"; alert("FORBIDDEN.\\nYour comment haven't been accepted due to error(s) in form.\\nTry again."); </script>~;
            }
            if ($in{'e'} eq '2'){
                  $messages .= qq~<script> scriptlanguarge="Javascript"; alert("FORBIDDEN.\\nYour IP address is in our black list."); </script>~;
            }
            if ($in{'e'} eq '3'){
                  $messages .= qq~<script> scriptlanguarge="Javascript"; alert("FORBIDDEN.\\nYou will be able to add your comment in $setup{'flud_min'} min."); </script>~;
            }
            if ($in{'e'} eq '4'){
                  $messages .= qq~<script> scriptlanguarge="Javascript"; alert("FORBIDDEN.\\nSorry but you can't add your comment because comments' limit was reached."); </script>~;
            }
            if ($in{'e'} eq '5'){
                  $messages .= qq~<script> scriptlanguarge="Javascript"; alert("FORBIDDEN.\\nSorry but you can't add your comment because one or more [QUOTE] tag wasn't close."); </script>~;
            }


            $show =~ s/\$MESSAGES\$/$messages/;
            $show =~ s/\$PAGES\$/$out/g;
            $show =~ s/\$INFO\$/$info/g;
            $show =~ s/\$ADD\$/$add/g;
            $show =~ s/\$BANNER\$/$banner/g;

            print "Content-type: text/html\n\n";
            print  $show;
            exit;
}

# *************************** SUB add **************************** #
sub add {
      if ($in{'a'} eq 'add'){

            my $id = time();
            my $ip = $ENV{'REMOTE_ADDR'};
            my ($date,$time,$wday)=timed(\%setup,\%date);

            my $c_time=time();

            open (FILE,"+<$datafd/flud.time") or die "Can't open time file to read\n$!";
                  flock FILE,2 if $system ne "NT";
                  my $c_t=<FILE>;
                  if ($c_time >= $c_t+1296000){
                        seek FILE,0,0;
                        truncate FILE,0;
                        print FILE $c_time;
                        open (F,">$datafd/flud.time.data") or die "Can't create time data file to read\n$!";
                        close(F);
                  }
            close(FILE);


            my $i=1;
            open (FILE,"<$datafd/flud.time.data") or die "Can't open time data file to read\n$!";
                  flock FILE,1 if $system ne "NT";
                  my @c_time=<FILE>;
            close(FILE);
            foreach (@c_time){
                  my @temp = split(/\|/,$_);
                  if ($temp[0] >= $c_time-($setup{'flud_min'}*60) and $temp[1] eq "$ip"){
                        $i++;
                  }
            }

            my @ban_ip = split(/\:/,$setup{'ban_ip'});
            foreach (@ban_ip){
                  if ($ip =~ /$_/){
                        print "Location: $setup{'cgi_url'}/$filename?e=2\n\n";
                        exit;
                  }
            }

            open (FILE,"<$datafd/data.data") or die "Can't open data file to read\n$!";
                  flock FILE,1 if $system ne "NT";
                  my @data=<FILE>;
            close(FILE);

            $in{'smile'}=symbols2codes($in{'smile'});

            $in{'icq'}=symbols2codes($in{'icq'});

            $in{'name'}=symbols2codes($in{'name'},2);

            $in{'email'} = symbols2codes($in{'email'});

            $in{'url'} = symbols2codes($in{'url'});
            $in{'url'} = email_url($in{'url'},'url');


            $in{'country'} = symbols2codes($in{'country'});
            $in{'city'} = symbols2codes($in{'city'});
            $in{'other1'} = symbols2codes($in{'other1'});
            $in{'other2'} = symbols2codes($in{'other2'});
            $in{'other3'} = symbols2codes($in{'other3'});

            $in{'message'} =~ s|([^ \;\/\\\[\]\=]{50,}?\S)|$1 |g;
            $in{'message'} = " $in{'message'}";
            $in{'message'} =~ s/^[\r\n]+//g;
            $in{'message'} =~ s/[\r\n]+$//g;
            $in{'message'} = symbols2codes($in{'message'},'html');
            $in{'message'} =~ s/(\r\n)+/<br>/ig;

            my ($start,$stop);
            $start++ if ($in{'message'} =~ /\[quote\]/ig);
            $start++ if ($in{'message'} =~ /\[q\]/ig);
            $start++ if ($in{'message'} =~ /\[quote=(.+?)\]/ig);
            $start++ if ($in{'message'} =~ /\[q=(.+?)\]/ig);


            $stop++ if ($in{'message'} =~ /\[\/quote\]/ig);
            $stop++ if ($in{'message'} =~ /\[\/q\]/ig);


            if ($start != $stop){
                  print "Location: $setup{'cgi_url'}/$filename?e=5\n\n";
                  exit;

            }

            if (length($in{'name'}) <= 1 or length($in{'name'}) > 100 or length($in{'email'}) > 100 or length($in{'url'}) > 100 or length($in{'icq'}) > 100 or length($in{'country'}) > 100 or length($in{'city'}) > 100 or length($in{'other1'}) >= 100 or length($in{'other2'}) >= 100 or length($in{'other3'}) >= 100 or length($in{'message'}) > $setup{'max_message'} or length($in{'message'}) <= 2){
                  print "Location: $setup{'cgi_url'}/$filename?e=1\n\n";
                  exit;
            }
            elsif ($i>1){
                  print "Location: $setup{'cgi_url'}/$filename?e=3\n\n";
                  exit;
            }
            elsif (scalar(@data) >= $setup{'max_messages'}){
                  send_mail("$setup{'email'}","$setup{'email'}","WOguest - Comments' Limit","Hello admin.\nYour visitors can't add comments due to the comments' limit was reached.\n\nVisit http://www.woscripts.com","$setup{'sendmail'}");
                  print "Location: $setup{'cgi_url'}/$filename?e=4\n\n";
                  exit;
            }
            else {
                  open (FILE, ">>$datafd/data.data") or die("Can't open template file for reading\n",$!);
                        flock FILE,2 if $system ne "NT";
                        print FILE "$id|$in{'name'}|$in{'email'}|$in{'url'}|$in{'icq'}|$in{'country'}|$in{'city'}|$in{'other1'}|$in{'other2'}|$in{'other3'}|$in{'smile'}|$ip|$date|$time|$wday|$in{'message'}||\n";
                  close(FILE);

                  open (FILE,">>$datafd/flud.time.data") or die "Can't open time data file to append\n$!";
                        flock FILE,2 if $system ne "NT";
                        print FILE "$c_time|$ip|\n";
                  close(FILE);

                  if ($in{'email'} ne '' and $setup{'email_to_user'} eq 'yes'){
                        send_mail("$in{'email'}","$setup{'email'}","WOguest - Thanks for your comments","Thanks for your comments, come back to our site again.\n\nPlease visit http://www.woscripts.com","$setup{'sendmail'}");
                  }
                  if ($setup{'email_tio_admin'} eq 'yes'){
                        send_mail("$setup{'email'}","$setup{'email'}","WOguest - New Comments","Hello admin.\nYou have new comments in your guest book.\n\nVisit http://www.woscripts.com","$setup{'sendmail'}");
                  }

                  print "Location: $filename\n\n";
                  exit;
            }
      }
      else {
            my $a_form = '';
            open (FILE, "<$datafd/templates/temp.a.data") or die("Can't open template file for reading\n",$!);
                  flock FILE,1 if $system ne "NT";
                  while (<FILE>){
                       $a_form .= $_;
                  }
            close(FILE);

            my $smile .= qq~

                        <table border="0" cellspacing="0" cellpadding="0">
                        <tr>
                        <td width="10%"><input class=smiles type="radio" value="1" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/1.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="2" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/2.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="3" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/3.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="4" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/4.gif" width="16" height="16"></td>
                        <td width="10%"><input class=smiles type="radio" value="5" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/5.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="6" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/6.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="7" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/7.gif" width="15" height="16"></td>
                        </tr>
                        <tr>
                        <td width="10%"><input class=smiles type="radio" value="8" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/8.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="9" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/9.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="10" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/10.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="11" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/11.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="12" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/12.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="13" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/13.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="14" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/14.gif" width="15" height="15"></td>
                        </tr>
                        <tr>
                        <td width="10%"><input class=smiles type="radio" value="15" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/15.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="16" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/16.gif" width="16" height="16"></td>
                        <td width="10%"><input class=smiles type="radio" value="17" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/17.gif" width="16" height="16"></td>
                        <td width="10%"><input class=smiles type="radio" value="18" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/18.gif" width="21" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="19" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/19.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="20" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/20.gif" width="15" height="15"></td>
                        <td width="10%"><input class=smiles type="radio" value="21" name="smile"><img border="0" src="$setup{'non_cgi'}/smiles/21.gif" width="15" height="15"></td>
                        </tr>
                        </table>
            ~;

            my $emotions = qq~

                  <script language="javascript">
                  <!--
                  function emoticon(theSmilie) {
                  document.add.message.value += ' ' + theSmilie + ' ';
                  document.add.message.focus();
                  }
                  //-->
                  </script>


                  <table border="0" cellpadding="4" style="border-width:1px; border-style:inset;">
                  <tr>
                  <td width="33%"><a href="javascript:emoticon(':)')"><img border="0" src="$setup{'non_cgi'}/emotions/smile.gif" alt="smilie" width="20" height="20"></td>
                  <td width="34%"><a href="javascript:emoticon(':D')"><img border="0" src="$setup{'non_cgi'}/emotions/biggrin.gif" alt="biggrin" width="20" height="20"></td>
                  <td width="33%"><a href="javascript:emoticon(';)')"><img border="0" src="$setup{'non_cgi'}/emotions/wink.gif" alt="wink" width="20" height="20"></td>
                  </tr>
                  <tr>
                  <td width="33%"><a href="javascript:emoticon(':angry:')"><img border="0" src="$setup{'non_cgi'}/emotions/angry.gif" alt="angry" width="20" height="20"></td>
                  <td width="34%"><a href="javascript:emoticon(':0')"><img border="0" src="$setup{'non_cgi'}/emotions/wow.gif" alt="wow" width="20" height="18"></td>
                  <td width="33%"><a href="javascript:emoticon(':hmm:')"><img border="0" src="$setup{'non_cgi'}/emotions/hmm.gif" alt="hmm" width="20" height="20"></td>
                  </tr>
                  <tr>
                  <td width="33%"><a href="javascript:emoticon(':cry:')"><img border="0" src="$setup{'non_cgi'}/emotions/cry.gif" alt="cry" width="20" height="20"></td>
                  <td width="34%"><a href="javascript:emoticon('???')"><img border="0" src="$setup{'non_cgi'}/emotions/confused.gif" alt="confused" width="20" height="18"></td>
                  <td width="33%"><a href="javascript:emoticon(':eh:')"><img border="0" src="$setup{'non_cgi'}/emotions/eh.gif" alt="eh" width="20" height="20"></td>
                  </tr>
                  <tr>
                  </tr>
                  <tr><td align="center" width="100%" colspan="3">
                  <a href="javascript://" onClick="window.open('smiles.cgi','Smiles','scrollbars=1,width=250,height=300,left=1,top=1')">$sign{'94'}</a>
                  </td></tr>
                  </table>
            ~;

            my $wocodes = qq~
                  <script language="javascript">
                  <!--

                  // Start the subroutines.

                  var Quote = 0;
                  var Code = 0;
                  var Bold  = 0;
                  var Italic = 0;
                  var Underline = 0;
                  var Line = 0;
                  var Over = 0;


                  // WO Code stuff
                  var text_enter_url      = "$error{'1'}";
                  var text_enter_url_name = "$error{'2'}";
                  var text_enter_image    = "$error{'3'}";
                  var text_enter_email    = "$error{'4'}";
                  var error_no_url        = "$error{'5'}";
                  var error_no_title      = "$error{'6'}";
                  var error_no_email      = "$error{'7'}";


                  function PostWrite(NewCode) {
                  document.add.message.value+=NewCode;
                  document.add.message.focus();
                  return;
                  }

                  function WOurl() {
                  var FoundErrors = '';
                  var enterURL   = prompt(text_enter_url, "http://");
                  var enterTITLE = prompt(text_enter_url_name, "Site Name");
                  if (!enterURL)    {
                  FoundErrors += "\\n" + error_no_url;
                  }
                  if (!enterTITLE)  {
                  FoundErrors += "\\n" + error_no_title;
                  }
                  if (FoundErrors)  {
                  alert("Error!"+FoundErrors);
                  return;
                  }
                  var ToAdd = "[URL="+enterURL+"]"+enterTITLE+"[/URL]";
                  document.add.message.value+=ToAdd;
                  document.add.message.focus();
                  }

                  function WOimage() {
                  var FoundErrors = '';
                  var enterURL   = prompt(text_enter_image, "http://");
                  if (!enterURL) {
                  FoundErrors += "\\n" + error_no_url;
                  }
                  if (FoundErrors) {
                  alert("Error!"+FoundErrors);
                  return;
                  }
                  var ToAdd = "[IMG]"+enterURL+"[/IMG]";
                  document.add.message.value+=ToAdd;
                  document.add.message.focus();
                  }

                  function WOemail() {
                  var emailAddress = prompt(text_enter_email,"");
                  if (!emailAddress) { alert(error_no_email); return; }
                  var ToAdd = "[EMAIL]"+emailAddress+"[/EMAIL]";
                  PostWrite(ToAdd);
                  }



                  function WOquote() {
                  if (Quote == 0) {
                  ToAdd = "[QUOTE]";
                  document.add.quote.value = " Quote*";
                  Quote = 1;
                  } else {
                  ToAdd = "[/QUOTE]";
                  document.add.quote.value = " Quote ";
                  Quote = 0;
                  }
                  PostWrite(ToAdd);
                  }


                  function WOcode() {
                  if (Code == 0) {
                  ToAdd = "[CODE]";
                  document.add.code.value = " Code*";
                  Code = 1;
                  } else {
                  ToAdd = "[/CODE]";
                  document.add.code.value = " Code ";
                  Code = 0;
                  }
                  PostWrite(ToAdd);
                  }

                  function WObold() {
                  if (Bold == 0) {
                  ToAdd = "[B]";
                  document.add.bold.value = " B*";
                  Bold = 1;
                  } else {
                  ToAdd = "[/B]";
                  document.add.bold.value = " B ";
                  Bold = 0;
                  }
                  PostWrite(ToAdd);
                  }

                  function WOitalic() {
                  if (Italic == 0) {
                  ToAdd = "[I]";
                  document.add.italic.value = " I*";
                  Italic = 1;
                  } else {
                  ToAdd = "[/I]";
                  document.add.italic.value = " I ";
                  Italic = 0;
                  }
                  PostWrite(ToAdd);
                  }

                  function WOline() {
                  if (Line == 0) {
                  ToAdd = "[S]";
                  document.add.line.value = " S*";
                  Line = 1;
                  } else {
                  ToAdd = "[/S]";
                  document.add.line.value = " S ";
                  Line = 0;
                  }
                  PostWrite(ToAdd);
                  }


                  function WOunder() {
                  if (Underline == 0) {
                  ToAdd = "[U]";
                  document.add.under.value = " U*";
                  Underline = 1;
                  } else {
                  ToAdd = "[/U]";
                  document.add.under.value = " U ";
                  Underline = 0;
                  }
                  PostWrite(ToAdd);
                  }

                  function WOover() {
                  if (Over == 0) {
                  ToAdd = "[O]";
                  document.add.over.value = " O*";
                  Over = 1;
                  } else {
                  ToAdd = "[/O]";
                  document.add.over.value = " O ";
                  Over = 0;
                  }
                  PostWrite(ToAdd);
                  }

                  function WOall() {
                  newWindow = window.open('codes.cgi','WOcodes','scrollbars=1,width=570,height=400,left=1,top=1');
                  }
                  //-->
                  </script>

                  <input type='button' accesskey='b' value=' B '       onClick='WObold()'   class='form_but' title="BOLD: [Ctrl / Alt] + b"      name='bold'   style="font-weight:bold">
                  <input type='button' accesskey='i' value=' I '       onClick='WOitalic()' class='form_but' title="ITALIC: [Ctrl / Alt] + i"    name='italic' style="font-style:italic">
                  <input type='button' accesskey='u' value=' U '       onClick='WOunder()'  class='form_but' title="UNDERLINE: [Ctrl / Alt] + u" name='under' style="text-decoration:underline">
                  <input type='button' accesskey='s' value=' S '       onClick='WOline()'  class='form_but' title="LINE-THROUGH: [Ctrl / Alt] + s" name='line' style="text-decoration:line-through">
                  <input type='button' accesskey='o' value=' O '       onClick='WOover()'  class='form_but' title="OVERLINE: [Ctrl / Alt] + o" name='over' style="text-decoration:overline">
                  <input type='button' accesskey='h' value=' http:// ' onClick='WOurl()'    class='form_but' title="HYPERLINK: [Ctrl / Alt] + h" style="text-decoration:underline;color:blue">
                  <input type='button' accesskey='e' value='  @  '     onClick='WOemail()'  class='form_but' title="EMAIL: [Ctrl / Alt] + e"     style="text-decoration:underline;color:blue">
                  <input type='button' accesskey='q' value=' Quote '   onClick='WOquote()'  class='form_but' title="QUOTE: [Ctrl / Alt] + q" name='quote'>
                  <input type='button' accesskey='c' value=' Code '   onClick='WOcode()'  class='form_but' title="CODE: [Ctrl / Alt] + c" name='code'>
                  <input type='button' accesskey='p' value=' Image ' onClick='WOimage()' class='form_but' title="PICTURE: [Ctrl or Alt] + p">
                  <input type='button' value='All codes' onClick='WOall()' class='form_but' title="ALL CODES">
            ~;

            $a_form =~ /\$COUNTER\:(\S+)\$/i;
            my $color = $1;
            my $counter = qq~

                  <script language="JavaScript">
                  <!--
                  var maxLen1=$setup{'max_message'};
                  function checkLen1(form)
                  {
                  str1 = document.add.message.value;
                  len1 = str1.length;
                  if ( len1 > maxLen1 ) document.add.message.value = str1.substring(0,maxLen1);
                  document.add.len1.value = (maxLen1 - document.add.message.value.length);
                  document.add.message.focus();
                  }
                  //-->
                  </script>
                  <!-- <input name=len1 type=hidden onChange=checkLen1(document.add) onKeyUp=checkLen1(document.add) value=0> -->
                  <input type="text" name="len1" value="$setup{'max_message'}" style="border:0px; background:$color" size=3 onChange="checkLen1(document.add)" onKeyUp="checkLen1(document.add)">
            ~;


            my $count = '';
               $count = 'onChange=checkLen1(document.add) onKeyUp=checkLen1(document.add)' if ($a_form =~ m|\$COUNTER:(\S+)\$|i);

            $a_form =~ s|\$MESSAGE:(\d+):(\d+)\$|<textarea rows="$2" cols="$1" class=message wrap='soft' tabindex='3' name="message" $count></textarea>|i;
            $a_form =~ s|\$WOCODES\$|$wocodes|i;
            $a_form =~ s|\$EMOTIONS\$|$emotions|i;
            $a_form =~ s|\$COUNTER:(\S+)\$|$counter|i;
            $a_form =~ s/\$NAME:(\d+)\$/<input type=\"text\" name=\"name\" size=\"$1\">/i;
            $a_form =~ s/\$EMAIL:(\d+)\$/<input type=\"text\" name="email" size=\"$1\">/i;
            $a_form =~ s/\$URL:(\d+)\$/<input type=\"text\" name=\"url\" size=\"$1\">/i;
            $a_form =~ s/\$ICQ:(\d+)\$/<input type=\"text\" name=\"icq\" size=\"$1\">/i;
            $a_form =~ s/\$CITY:(\d+)\$/<input type=\"text\" name=\"city\" size=\"$1\">/i;
            $a_form =~ s/\$COUNTRY:(\d+)\$/<input type=\"text\" name=\"country\" size=\"$1\">/i;
            $a_form =~ s/\$SMILE\$/$smile/i;
            $a_form =~ s/\$OTHER1:(\d+)\$/<input type=\"text\" name=\"other1\" size=\"$1\">/i;
            $a_form =~ s/\$OTHER2:(\d+)\$/<input type=\"text\" name=\"other2\" size=\"$1\">/i;
            $a_form =~ s/\$OTHER3:(\d+)\$/<input type=\"text\" name=\"other3\" size=\"$1\">/i;

            my $add_form = qq~

                        <form method="POST" name="add" action="$setup{'cgi_url'}/$filename">

                        $a_form

                        <input type="hidden" name="a" value="add">
                        </form>
            ~;
      return $add_form;
      }
}

# ************************** SUB rotator ************************* #
sub rotator {
      my $banner = '';
      open(FILE,"$datafd/banners/main.data");
            flock FILE,1  if $system ne "NT";
            my @ads = <FILE>;
      close(FILE);
      my @choose=();
      for (my $i = 0; $i <= $#ads; $i++) {
            chomp($ads[$i]);
            my ($file,$weight,$page,$max) = split(/\|/, $ads[$i]);
            $page = "/" . $page;
            for (my $j = 1; $j <= $weight; $j++) {
                  if (($page ne "/" && $page eq $ENV{'DOCUMENT_URI'}) || ($page eq "/")) { splice(@choose,0,0,$i); }
            }
      }
      my $adnum = int(rand($#choose));
      my ($file,$weight,$page,$max) = split(/\|/, $ads[$choose[$adnum]]);
      open(FILE,"$datafd/banners/$file.ad.data");
            flock FILE,1  if $system ne "NT";
            while (<FILE>){
                  $banner .= $_;
            }
      close(FILE);
      open(FILE,"$datafd/banners/$file.count.data");
            flock FILE,2  if $system ne "NT";
            my $count = <FILE>;
      close(FILE);
      $count++;
      unless ($max && $count >= $max) {
            open(FILE,">$datafd/banners/$file.count.data");
                  flock FILE,2  if $system ne "NT";
                  print FILE "$count";
            close(FILE);
      }
      else {
            splice(@ads,$choose[$adnum],1);
            open(FILE,">$datafd/banners/main.data");
                  flock FILE,2  if $system ne "NT";
                  foreach my $ad(@ads) { print FILE "$ad\n"; }
            close(FILE);
            unlink("$datafd/banners/$file.count.data");
            unlink("$datafd/banners/$file.ad.data");
      }
      return $banner;
}

# ************************** SUB add_form ********************* #
sub add_form {
            my $show='';

            open (FILE, "<$datafd/templates/temp.m.data") or die("Can't open template file for reading\n",$!);
                  flock FILE,1 if $system ne "NT";
                  while (<FILE>){
                       $show .= $_;
                  }
            close(FILE);

            my $banner = rotator();
            my $add = add();

            $show =~ s/\$MESSAGES\$//;
            $show =~ s/\$PAGES\$//g;
            $show =~ s/\$INFO\$//g;
            $show =~ s/\$ADD\$/$add/g;
            $show =~ s/\$BANNER\$/$banner/g;

            print "Content-type: text/html\n\n";
            print  $show;
            exit;
}

sub chomp_url {
    my ($the_red_sea) = @_;
    return $the_red_sea   if    $the_red_sea =~ /^<img src=/;
    return $the_red_sea unless length($the_red_sea) > 70;
    return $the_red_sea unless $the_red_sea =~ m!://!;
    # Fix up 'dem pesky ampersands
    $the_red_sea =~ s!&amp;!&!g;
    $the_red_sea =~ s!(?:(\?)|[&;])s=[\w\d]{16,32}(?:&|;|$)!$1!g;
    my ($moses, $did_indeed) = split /\:\/\//, $the_red_sea;
    my @miracle = split "/",$did_indeed;
    my $worker = substr($miracle[1], 0, 7,);
    my $maybe  = substr($miracle[$#miracle],length($miracle[$#miracle])-7);
    return $moses.'://'.$miracle[0].'/'.$worker.'....'.$maybe;
}

sub check_size{
      my $size = shift;
      unless ($size =~ /\d+/){$size = 10;}
      if ($size < 8){$size = 8;}
      if ($size > 25){$size = 25;}

      return $size;
}